require 'modshogun'

f_feats_train = modshogun.CSVFile("../../data/classifier_binary_2d_linear_features_train.dat")
Math:init_random(1)

--![create_features]
features_train = modshogun.RealFeatures(f_feats_train)
--![create_features]

--![choose_distance]
distance = modshogun.EuclideanDistance(features_train, features_train)
--![choose_distance]

--![create_instance_lloyd]
kmeans = modshogun.KMeans(2, distance)
--![create_instance_lloyd]

--![train_dataset]
kmeans:train()
--![train_dataset]

--![extract_centers_and_radius]
c = kmeans:get_cluster_centers()
r = kmeans:get_radiuses()
--![extract_centers_and_radius]

--![create_instance_mb]
kmeans_mb = modshogun.KMeansMiniBatch(2, distance)
kmeans_mb:set_mb_params(4, 1000)
--![create_instance_mb]

-- Serialize output for integration testing (automatically generated)
__sg_storage = modshogun.WrappedObjectArray()
__sg_storage_file = modshogun.SerializableAsciiFile("kmeans.dat", 'w')
__sg_storage:append_wrapped_real_matrix(c, "c")
__sg_storage:append_wrapped_real_vector(r, "r")
__sg_storage:save_serializable(__sg_storage_file)
