require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/classifier_binary_2d_linear_labels_test.dat"

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::BinaryLabels.new f_labels_train
labels_test = Modshogun::BinaryLabels.new f_labels_test
#![create_features]

#![set_parameters]
learn_rate = 1.0
max_iter = 1000
perceptron = Modshogun::AveragedPerceptron.new features_train, labels_train
perceptron.set_learn_rate learn_rate
perceptron.set_max_iter max_iter
#![set_parameters]

#![train_and_apply]
perceptron.train 
perceptron.set_features features_test
labels_predict = perceptron.apply 
#![train_and_apply]

#![extract_weights]
weights = perceptron.get_w 
bias = perceptron.get_bias 
#![extract_weights]

#![evaluate_accuracy]
eval = Modshogun::AccuracyMeasure.new 
accuracy = eval.evaluate labels_predict, labels_test
#![evaluate_accuracy]

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "averaged_perceptron.dat", 'w'
__sg_storage.append_wrapped_real learn_rate, "learn_rate"
__sg_storage.append_wrapped_int max_iter, "max_iter"
__sg_storage.append_wrapped_real_vector weights, "weights"
__sg_storage.append_wrapped_real bias, "bias"
__sg_storage.append_wrapped_real accuracy, "accuracy"
__sg_storage.save_serializable __sg_storage_file
