require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/regression_1d_sinc_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/regression_1d_sinc_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/regression_1d_sinc_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/regression_1d_sinc_labels_test.dat"

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::RegressionLabels.new f_labels_train
labels_test = Modshogun::RegressionLabels.new f_labels_test
#![create_features]

#![create_appropriate_kernel]
width = 1.0
kernel = Modshogun::GaussianKernel.new features_train, features_train, width
#![create_appropriate_kernel]

#![create_instance]
tau = 0.001
m = 100
nystrom = Modshogun::KRRNystrom.new tau, m, kernel, labels_train
#![create_instance]

#![train_and_apply]
nystrom.train 
labels_predict = nystrom.apply_regression features_test
#![train_and_apply]

#![extract_alpha]
alpha = nystrom.get_alphas 
#![extract_alpha]

#![evaluate_error]
eval = Modshogun::MeanSquaredError.new 
mse = eval.evaluate labels_predict, labels_test
#![evaluate_error]

# integration testing variables
output = labels_test.get_labels 

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "krr_nystrom.dat", 'w'
__sg_storage.append_wrapped_real width, "width"
__sg_storage.append_wrapped_real tau, "tau"
__sg_storage.append_wrapped_int m, "m"
__sg_storage.append_wrapped_real_vector alpha, "alpha"
__sg_storage.append_wrapped_real mse, "mse"
__sg_storage.append_wrapped_real_vector output, "output"
__sg_storage.save_serializable __sg_storage_file
